change = list(
  function(landscape, change.parameters, ...){
    
    #change.parameters = landscape.parameters$change.parameters
    #landscape = result[[1]][[1]][["landscapes"]][[1]][[6]]
    #change.parameters = change.parameters[[1]]
    require(sf)
    source('code/vectr.R')
    
    v = vectr(landscape, change.parameters$class)
    
    n = nrow(v)
    
    changed.landscapes = list(landscape)
    for (step in 1:change.parameters$steps){
      
      rate = step * change.parameters$rate
      
      count = floor(n * rate)
      
      if (count == 0){
        count = 1
      }
      
      n = n - count
      
      if (n < 0){
        n = 0
      }
      
      if (n > nrow(v)){
        n = nrow(v)
      }
      
      v = v[sample(nrow(v), n),]
      
      source('code/rastr.R')
      
      sampled.array = rastr(v, nrow(landscape))
      
      changed.landscape = landscape
      
      changed.landscape[landscape == change.parameters$class & is.na(sampled.array)] = change.parameters$background
      
      changed.landscapes = c(changed.landscapes, list(changed.landscape))
      
    }
    
    return(changed.landscapes)
  },
  
  function(landscape, change.parameters, ...){
    
    
    #change.parameters = change.parameters[[2]]
    
    #class.index = ifelse(change.parameters$class == 5, 3, ifelse(change.parameters$class == 3, 2, 0))
    class.index = change.parameters$class
    q = ..1[[class.index]]$func.parameters$q
    noise = ..2[[class.index]][[1]]
    
    
    n = nrow(noise)
    
    changed.landscapes = list(landscape)
    for (step in 1:change.parameters$steps){
        
      rate = step * change.parameters$rate
      
      classified.noise = matrix(as.integer(noise < as.numeric(quantile(noise, c(q + (q * rate))))),
                                n,
                                n
                                )
        
      changed.landscape = landscape
        
      changed.landscape[landscape %in% change.parameters$background & classified.noise == 1] = change.parameters$class
        
      changed.landscapes = c(changed.landscapes, list(changed.landscape))
      
    }
    
    return(changed.landscapes)
  }
)
  