network = function(classified.noise, size, scale, seed){
  
  source('code/vectr.R')
  
  require(sf)
  require(dplyr)
  
  classified.noise = vectr(classified.noise)
  
  classified.noise = classified.noise %>%
    top_n(sqrt(size), st_area(.)) %>%
    arrange(desc(st_area(.)))
  
  source('code/line.R')
  
  set.seed(seed)
  
  
  l = line(st_sfc(st_point(matrix(sample(seq(0, size, 2), 2)*scale, 1)),
                  st_point(matrix(sample(seq(1, size-1, 2), 2)*scale, 1))),
           size*scale)
  
  
  if (nrow(classified.noise) != 0){
    for (i in 1:nrow(classified.noise)){
      L = st_nearest_points(classified.noise[i,], l) %>% st_sf
      
      l = rbind(l, L)
      l = l %>% st_union
    }
  }
  
  source('code/rastr.R')
  
  #l = rasterize_features(l, (100*size.f))
  l = rastr(l, size*scale) 
  
  return(l)
}