parameters = function(n.runs, start.seed, size, scale, mmu){
  source('code/croft.R')
  source('code/road.R')
  source('code/layer.R')
  
  parameters = list(
    size = size,
    scale = scale,
    mmu = mmu,
    random.parameters = lapply(as.list(1:n.runs), function(x){
      set.seed(x + start.seed)
      
      list(
        list(func.parameters = list(
          f = runif(1, .005, .01),
          q = runif(1, 0, .1)),
             func = layer),
        list(func.parameters = list(
          f = runif(1, .001, .01),
          q = runif(1, .05, .25)),
             func = layer),
        list(func.parameters = list(
          f = runif(1, .005, .05),
          q = runif(1, .5, .9)),
             func = layer)
      )
    }
    ),
    feature.parameters = list(list(3, croft),
                              list(2 , road)
    )
  )
  
  return(parameters)
}