run = function(n.runs, start.seed, size, scale, mmu, n.cores, n.reps){
  
  source('code/parameters.R')
  source('code/check_dependencies.R')
  
  check_dependencies()
  # n.runs = n.runs
  # start.seed = start.seed
  # size = size 
  # scale = scale
  # mmu = mmu
  # n.cores = n.cores 
  # n.reps = n.reps
  
  parameters = parameters(n.runs, start.seed, size, scale, mmu)
  
  require(parallel)
  
  source('code/change_function.R')
  source('code/calculate_function.R')
  source('code/simulate_function.R')
  source('code/index_list.R')
  
  
  time = format(Sys.time(), '%d%m%y_%H%M')
  dir.create(paste0('data/', time))
  saveRDS(list(parameters = parameters,
               change.func = change.func,
               calculate.func = calculate.func,
               simulate.func = simulate.func),
          paste0('data/', time, '/params.Rdata'))
  
  lapply(index_list(parameters$random.parameters), function(x){
  
    random.parameters = parameters$random.parameters[[x]]
    #dir.create(paste0('data/', time, '/var', x))
    
    r = as.list(1:(n.cores*n.reps))
    
    while(length(which(sapply(r, class) != 'list')) != 0){
      i = which(sapply(r, class) != 'list')
      r[i] = mclapply(as.list(1:(n.cores * n.reps)), function(y){
        source('code/landscape.R')
        simulate.func(parameters = parameters,
                      random.parameters = random.parameters,
                      seed = y, 
                      #time = time,
                      var = x + start.seed
                      )
        },
        mc.cores = n.cores
      )
    }
    
    saveRDS(r, paste0('data/', time, '/', x, '.Rdata'))
    
    #return(r)
    return(T)
  })
  return(paste0('data/', time, '/'))
}